Index: src/Actions/GeometryAction/GeometryDistanceToVectorAction.cpp
===================================================================
--- src/Actions/GeometryAction/GeometryDistanceToVectorAction.cpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
+++ src/Actions/GeometryAction/GeometryDistanceToVectorAction.cpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
@@ -0,0 +1,107 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2017 Frederik Heber. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * GeometryDistanceToVectorAction.cpp
+ *
+ *  Created on: Mar 28, 2017
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+//#include "CodePatterns/MemDebug.hpp"
+
+#include "CodePatterns/Assert.hpp"
+#include "CodePatterns/Log.hpp"
+
+#include <string>
+
+#include "Atom/atom.hpp"
+#include "Geometry/GeometryObject.hpp"
+#include "Geometry/GeometryRegistry.hpp"
+#include "World.hpp"
+
+#include "Actions/GeometryAction/GeometryDistanceToVectorAction.hpp"
+
+using namespace MoleCuilder;
+
+// and construct the stuff
+#include "../GeometryAction/GeometryDistanceToVectorAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+ActionState::ptr GeometryDistanceToVectorAction::performCall() {
+  // check preconditions
+  World& world = World::getInstance();
+  if (world.countSelectedAtoms() != 2) {
+    STATUS("There must be exactly two atoms selected for GeometryAction DistanceToVector.");
+    return Action::failure;
+  }
+  if (GeometryRegistry::getInstance().isPresentByName(params.name.get())) {
+    STATUS("Name "+params.name.get()+" already present in registry.");
+    return Action::failure;
+  }
+
+  World::AtomSelectionIterator iter = world.beginAtomSelection();
+  const atom * const Walker = (iter++)->second;
+  const atom * const OtherWalker = (iter++)->second;
+  ASSERT( iter == world.endAtomSelection(),
+      "GeometryDistanceToVectorAction::performCall() - selection iter not at end?");
+  const Vector distance = (Walker->getPosition() - OtherWalker->getPosition())
+      * (params.reverse.get() ? -1. : 1.);
+  const GeometryObject vec(distance, params.name.get());
+  LOG(4, "DEBUG: Adding geometry object " << vec << " with norm " << distance.Norm());
+  GeometryRegistry::getInstance().addGeometry(vec);
+
+  GeometryDistanceToVectorState *UndoState = new GeometryDistanceToVectorState(distance, params);
+  return ActionState::ptr(UndoState);
+}
+
+ActionState::ptr GeometryDistanceToVectorAction::performUndo(ActionState::ptr _state) {
+//  GeometryDistanceToVectorState *state = assert_cast<GeometryDistanceToVectorState*>(_state.get());
+
+  GeometryRegistry::getInstance().removeGeometry(params.name.get());
+
+  return ActionState::ptr(_state);
+}
+
+ActionState::ptr GeometryDistanceToVectorAction::performRedo(ActionState::ptr _state){
+  GeometryDistanceToVectorState *state = assert_cast<GeometryDistanceToVectorState*>(_state.get());
+
+  const GeometryObject vec(state->distance, params.name.get());
+  LOG(4, "DEBUG: Adding geometry object " << vec);
+  GeometryRegistry::getInstance().addGeometry(vec);
+
+  return ActionState::ptr(_state);
+}
+
+bool GeometryDistanceToVectorAction::canUndo() {
+  return true;
+}
+
+bool GeometryDistanceToVectorAction::shouldUndo() {
+  return true;
+}
+/** =========== end of function ====================== */
Index: src/Actions/GeometryAction/GeometryDistanceToVectorAction.def
===================================================================
--- src/Actions/GeometryAction/GeometryDistanceToVectorAction.def	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
+++ src/Actions/GeometryAction/GeometryDistanceToVectorAction.def	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
@@ -0,0 +1,36 @@
+/*
+ * GeometryDistanceToVectorAction.cpp
+ *
+ *  Created on: Mar 28, 2017
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "Parameters/Validators/Specific/GeometryNameValidator.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+//#define paramtypes (const element *)(BoxVector) TODO: use a validator
+#define paramtypes (std::string)(bool)
+#define paramtokens ("distance-to-vector")("reverse")
+#define paramdescriptions ("name for geometry object for reference as vector")("whether to invert the resulting vector") 
+#define paramreferences (name)(reverse)
+#define paramdefaults (NOPARAM_DEFAULT())(PARAM_DEFAULT(0))
+#define paramvalids \
+(GeometryNameValidator()) \
+(DummyValidator<bool>())
+
+#define statetypes (Vector)
+#define statereferences (distance)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Geometry
+#define MENUNAME "geometry"
+#define MENUPOSITION 1
+#define ACTIONNAME DistanceToVector
+#define TOKEN "distance-to-vector"
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "stores the distance vector between two selected atom as a named geometry object"
+#undef SHORTFORM
Index: src/Actions/GeometryAction/GeometryDistanceToVectorAction.hpp
===================================================================
--- src/Actions/GeometryAction/GeometryDistanceToVectorAction.hpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
+++ src/Actions/GeometryAction/GeometryDistanceToVectorAction.hpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
@@ -0,0 +1,22 @@
+/*
+ * GeometryDistanceToVectorAction.hpp
+ *
+ *  Created on: Mar 28, 2017
+ *      Author: heber
+ */
+
+#ifndef GEOMETRYDISTANCETOVECTORACTION_HPP_
+#define GEOMETRYDISTANCETOVECTORACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "Actions/Action.hpp"
+
+#include "../GeometryAction/GeometryDistanceToVectorAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* GEOMETRYDISTANCETOVECTORACTION_HPP_ */
Index: src/Actions/GeometryAction/GeometryInputToVectorAction.cpp
===================================================================
--- src/Actions/GeometryAction/GeometryInputToVectorAction.cpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
+++ src/Actions/GeometryAction/GeometryInputToVectorAction.cpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
@@ -0,0 +1,91 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2017 Frederik Heber. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * GeometryInputToVectorAction.cpp
+ *
+ *  Created on: Mar 28, 2017
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+//#include "CodePatterns/MemDebug.hpp"
+
+#include "CodePatterns/Log.hpp"
+
+#include <string>
+
+#include "Geometry/GeometryObject.hpp"
+#include "Geometry/GeometryRegistry.hpp"
+
+#include "Actions/GeometryAction/GeometryInputToVectorAction.hpp"
+
+using namespace MoleCuilder;
+
+// and construct the stuff
+#include "../GeometryAction/GeometryInputToVectorAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+ActionState::ptr GeometryInputToVectorAction::performCall() {
+  // check preconditions
+  if (GeometryRegistry::getInstance().isPresentByName(params.name.get())) {
+    STATUS("Name "+params.name.get()+" already present in registry.");
+    return Action::failure;
+  }
+
+  const GeometryObject vec(params.vec.get(), params.name.get());
+  LOG(4, "DEBUG: Adding geometry object " << vec << " with norm " << params.vec.get().Norm());
+  GeometryRegistry::getInstance().addGeometry(vec);
+
+  return Action::success;
+}
+
+ActionState::ptr GeometryInputToVectorAction::performUndo(ActionState::ptr _state) {
+//  GeometryInputToVectorState *state = assert_cast<GeometryInputToVectorState*>(_state.get());
+
+  GeometryRegistry::getInstance().removeGeometry(params.name.get());
+
+  return Action::success;
+}
+
+ActionState::ptr GeometryInputToVectorAction::performRedo(ActionState::ptr _state){
+//  GeometryInputToVectorState *state = assert_cast<GeometryInputToVectorState*>(_state.get());
+
+  const GeometryObject vec(params.vec.get(), params.name.get());
+  LOG(4, "DEBUG: Adding geometry object " << vec);
+  GeometryRegistry::getInstance().addGeometry(vec);
+
+  return Action::success;
+}
+
+bool GeometryInputToVectorAction::canUndo() {
+  return true;
+}
+
+bool GeometryInputToVectorAction::shouldUndo() {
+  return true;
+}
+/** =========== end of function ====================== */
Index: src/Actions/GeometryAction/GeometryInputToVectorAction.def
===================================================================
--- src/Actions/GeometryAction/GeometryInputToVectorAction.def	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
+++ src/Actions/GeometryAction/GeometryInputToVectorAction.def	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
@@ -0,0 +1,37 @@
+/*
+ * GeometryInputToVectorAction.cpp
+ *
+ *  Created on: Mar 28, 2017
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "Parameters/Validators/Specific/GeometryNameValidator.hpp"
+#include "Parameters/Validators/DummyValidator.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+//#define paramtypes (const element *)(BoxVector) TODO: use a validator
+#define paramtypes (std::string)(Vector)
+#define paramtokens ("input-to-vector")("coordinates")
+#define paramdescriptions ("name for geometry object for reference as vector")("vector coordinates") 
+#define paramreferences (name)(vec)
+#define paramdefaults (NOPARAM_DEFAULT())(NOPARAM_DEFAULT())
+#define paramvalids \
+(GeometryNameValidator()) \
+(DummyValidator<Vector>())
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Geometry
+#define MENUNAME "geometry"
+#define MENUPOSITION 1
+#define ACTIONNAME InputToVector
+#define TOKEN "input-to-vector"
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "stores the given vector as a named geometry object"
+#undef SHORTFORM
Index: src/Actions/GeometryAction/GeometryInputToVectorAction.hpp
===================================================================
--- src/Actions/GeometryAction/GeometryInputToVectorAction.hpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
+++ src/Actions/GeometryAction/GeometryInputToVectorAction.hpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
@@ -0,0 +1,22 @@
+/*
+ * GeometryInputToVectorAction.hpp
+ *
+ *  Created on: Mar 28, 2017
+ *      Author: heber
+ */
+
+#ifndef GEOMETRYINPUTTOVECTORACTION_HPP_
+#define GEOMETRYINPUTTOVECTORACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "Actions/Action.hpp"
+
+#include "../GeometryAction/GeometryInputToVectorAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* GEOMETRYINPUTTOVECTORACTION_HPP_ */
Index: src/Actions/GeometryAction/GeometryPlaneToVectorAction.cpp
===================================================================
--- src/Actions/GeometryAction/GeometryPlaneToVectorAction.cpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
+++ src/Actions/GeometryAction/GeometryPlaneToVectorAction.cpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
@@ -0,0 +1,116 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2017 Frederik Heber. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * GeometryPlaneToVectorAction.cpp
+ *
+ *  Created on: Mar 28, 2017
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+//#include "CodePatterns/MemDebug.hpp"
+
+#include "CodePatterns/Log.hpp"
+
+#include <string>
+
+#include "LinearAlgebra/Plane.hpp"
+
+#include "Atom/atom.hpp"
+#include "Geometry/GeometryObject.hpp"
+#include "Geometry/GeometryRegistry.hpp"
+#include "World.hpp"
+
+#include "Actions/GeometryAction/GeometryPlaneToVectorAction.hpp"
+
+using namespace MoleCuilder;
+
+// and construct the stuff
+#include "../GeometryAction/GeometryPlaneToVectorAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+ActionState::ptr GeometryPlaneToVectorAction::performCall() {
+  // check preconditions
+  World& world = World::getInstance();
+  if (world.countSelectedAtoms() != 3) {
+    STATUS("There must be exactly three atoms selected for GeometryAction PlaneToVector.");
+    return Action::failure;
+  }
+  if (GeometryRegistry::getInstance().isPresentByName(params.name.get())) {
+    STATUS("Name "+params.name.get()+" already present in registry.");
+    return Action::failure;
+  }
+
+  World::AtomSelectionIterator iter = world.beginAtomSelection();
+  const atom * const Walker = (iter++)->second;
+  const atom * const OtherWalker = (iter++)->second;
+  const atom * const AnotherWalker = (iter++)->second;
+  ASSERT( iter == world.endAtomSelection(),
+      "GeometryDistanceToVectorAction::performCall() - selection iter not at end?");
+  Vector PlaneNormal;
+  try {
+    const Plane AtomPlane(Walker->getPosition(), OtherWalker->getPosition(), AnotherWalker->getPosition());
+    PlaneNormal = AtomPlane.getNormal();
+  } catch (LinearDependenceException &e) {
+    ELOG(2, "The selected atomic positions are linearly dependent.");
+    return Action::failure;
+  }
+  PlaneNormal *= (params.reverse.get() ? -1. : 1.);
+  const GeometryObject vec(PlaneNormal, params.name.get());
+  LOG(4, "DEBUG: Adding geometry object " << vec << " with norm " << PlaneNormal.Norm());
+  GeometryRegistry::getInstance().addGeometry(vec);
+
+  GeometryPlaneToVectorState *UndoState = new GeometryPlaneToVectorState(PlaneNormal, params);
+  return ActionState::ptr(UndoState);
+}
+
+ActionState::ptr GeometryPlaneToVectorAction::performUndo(ActionState::ptr _state) {
+//  GeometryPlaneToVectorState *state = assert_cast<GeometryPlaneToVectorState*>(_state.get());
+
+  GeometryRegistry::getInstance().removeGeometry(params.name.get());
+
+  return ActionState::ptr(_state);
+}
+
+ActionState::ptr GeometryPlaneToVectorAction::performRedo(ActionState::ptr _state){
+  GeometryPlaneToVectorState *state = assert_cast<GeometryPlaneToVectorState*>(_state.get());
+
+  const GeometryObject vec(state->PlaneNormal, params.name.get());
+  LOG(4, "DEBUG: Adding geometry object " << vec);
+  GeometryRegistry::getInstance().addGeometry(vec);
+
+  return ActionState::ptr(_state);
+}
+
+bool GeometryPlaneToVectorAction::canUndo() {
+  return true;
+}
+
+bool GeometryPlaneToVectorAction::shouldUndo() {
+  return true;
+}
+/** =========== end of function ====================== */
Index: src/Actions/GeometryAction/GeometryPlaneToVectorAction.def
===================================================================
--- src/Actions/GeometryAction/GeometryPlaneToVectorAction.def	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
+++ src/Actions/GeometryAction/GeometryPlaneToVectorAction.def	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
@@ -0,0 +1,36 @@
+/*
+ * GeometryPlaneToVectorAction.cpp
+ *
+ *  Created on: Mar 28, 2017
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "Parameters/Validators/Specific/GeometryNameValidator.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+//#define paramtypes (const element *)(BoxVector) TODO: use a validator
+#define paramtypes (std::string)(bool)
+#define paramtokens ("plane-to-vector")("reverse")
+#define paramdescriptions ("name for geometry object for reference as vector")("whether to invert the resulting vector") 
+#define paramreferences (name)(reverse)
+#define paramdefaults (NOPARAM_DEFAULT())(PARAM_DEFAULT(0))
+#define paramvalids \
+(GeometryNameValidator()) \
+(DummyValidator<bool>())
+
+#define statetypes (Vector)
+#define statereferences (PlaneNormal)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Geometry
+#define MENUNAME "geometry"
+#define MENUPOSITION 3
+#define ACTIONNAME PlaneToVector
+#define TOKEN "plane-to-vector"
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "stores the plane defined by three selected atom as a named geometry object"
+#undef SHORTFORM
Index: src/Actions/GeometryAction/GeometryPlaneToVectorAction.hpp
===================================================================
--- src/Actions/GeometryAction/GeometryPlaneToVectorAction.hpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
+++ src/Actions/GeometryAction/GeometryPlaneToVectorAction.hpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
@@ -0,0 +1,22 @@
+/*
+ * GeometryPlaneToVectorAction.hpp
+ *
+ *  Created on: Mar 28, 2017
+ *      Author: heber
+ */
+
+#ifndef GEOMETRYPLANETOVECTORACTION_HPP_
+#define GEOMETRYPLANETOVECTORACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "Actions/Action.hpp"
+
+#include "../GeometryAction/GeometryPlaneToVectorAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* GEOMETRYPLANETOVECTORACTION_HPP_ */
Index: src/Actions/GeometryAction/GeometryPositionToVectorAction.cpp
===================================================================
--- src/Actions/GeometryAction/GeometryPositionToVectorAction.cpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
+++ src/Actions/GeometryAction/GeometryPositionToVectorAction.cpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
@@ -0,0 +1,101 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2017 Frederik Heber. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * GeometryPositionToVectorAction.cpp
+ *
+ *  Created on: Mar 27, 2017
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+//#include "CodePatterns/MemDebug.hpp"
+
+#include "CodePatterns/Log.hpp"
+
+#include <string>
+
+#include "Atom/atom.hpp"
+#include "Geometry/GeometryObject.hpp"
+#include "Geometry/GeometryRegistry.hpp"
+#include "World.hpp"
+
+#include "Actions/GeometryAction/GeometryPositionToVectorAction.hpp"
+
+using namespace MoleCuilder;
+
+// and construct the stuff
+#include "../GeometryAction/GeometryPositionToVectorAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+ActionState::ptr GeometryPositionToVectorAction::performCall() {
+  // check preconditions
+  World& world = World::getInstance();
+  if (world.countSelectedAtoms() != 1) {
+    STATUS("There must be exactly one atom selected for GeometryAction PositionToVector.");
+    return Action::failure;
+  }
+  if (GeometryRegistry::getInstance().isPresentByName(params.name.get())) {
+    STATUS("Name "+params.name.get()+" already present in registry.");
+    return Action::failure;
+  }
+
+  const atom * const Walker = world.beginAtomSelection()->second;
+  const Vector position = Walker->getPosition();
+  const GeometryObject vec(position, params.name.get());
+  LOG(4, "DEBUG: Adding geometry object " << vec << " with norm " << position.Norm());
+  GeometryRegistry::getInstance().addGeometry(vec);
+
+  GeometryPositionToVectorState *UndoState = new GeometryPositionToVectorState(position, params);
+  return ActionState::ptr(UndoState);
+}
+
+ActionState::ptr GeometryPositionToVectorAction::performUndo(ActionState::ptr _state) {
+//  GeometryPositionToVectorState *state = assert_cast<GeometryPositionToVectorState*>(_state.get());
+
+  GeometryRegistry::getInstance().removeGeometry(params.name.get());
+
+  return ActionState::ptr(_state);
+}
+
+ActionState::ptr GeometryPositionToVectorAction::performRedo(ActionState::ptr _state){
+  GeometryPositionToVectorState *state = assert_cast<GeometryPositionToVectorState*>(_state.get());
+
+  const GeometryObject vec(state->position, params.name.get());
+  LOG(4, "DEBUG: Adding geometry object " << vec);
+  GeometryRegistry::getInstance().addGeometry(vec);
+
+  return ActionState::ptr(_state);
+}
+
+bool GeometryPositionToVectorAction::canUndo() {
+  return true;
+}
+
+bool GeometryPositionToVectorAction::shouldUndo() {
+  return true;
+}
+/** =========== end of function ====================== */
Index: src/Actions/GeometryAction/GeometryPositionToVectorAction.def
===================================================================
--- src/Actions/GeometryAction/GeometryPositionToVectorAction.def	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
+++ src/Actions/GeometryAction/GeometryPositionToVectorAction.def	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
@@ -0,0 +1,35 @@
+/*
+ * GeometryPositionToVectorAction.cpp
+ *
+ *  Created on: Mar 27, 2017
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "Parameters/Validators/Specific/GeometryNameValidator.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+//#define paramtypes (const element *)(BoxVector) TODO: use a validator
+#define paramtypes (std::string)
+#define paramtokens ("position-to-vector")
+#define paramdescriptions ("name for geometry object for reference as vector") 
+#define paramreferences (name)
+#define paramdefaults (NOPARAM_DEFAULT())
+#define paramvalids \
+(GeometryNameValidator())
+
+#define statetypes (Vector)
+#define statereferences (position)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Geometry
+#define MENUNAME "geometry"
+#define MENUPOSITION 1
+#define ACTIONNAME PositionToVector
+#define TOKEN "position-to-vector"
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "stores the position of the selected atom as a named geometry object"
+#undef SHORTFORM
Index: src/Actions/GeometryAction/GeometryPositionToVectorAction.hpp
===================================================================
--- src/Actions/GeometryAction/GeometryPositionToVectorAction.hpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
+++ src/Actions/GeometryAction/GeometryPositionToVectorAction.hpp	(revision 5f869d731c0e018ae107f17a253937a99d0c6c9b)
@@ -0,0 +1,22 @@
+/*
+ * GeometryPositionToVectorAction.hpp
+ *
+ *  Created on: Mar 27, 2017
+ *      Author: heber
+ */
+
+#ifndef GEOMETRYPOSITIONTOVECTORACTION_HPP_
+#define GEOMETRYPOSITIONTOVECTORACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "Actions/Action.hpp"
+
+#include "../GeometryAction/GeometryPositionToVectorAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* GEOMETRYPOSITIONTOVECTORACTION_HPP_ */
